'''
Created on Sep 5, 2011

@author: lucas
'''
import networkx as nx
import matplotlib.pyplot as plt
import random

import ipdb

class Graph():
    '''
    generates the graph for the report
    '''
    
    def __init__(self):
        self.G = nx.Graph()

    def buildGraphFromResults(self, aMossResultList, aLocalResultDict):
        '''
        builds a graph that represents results list
        '''
        if aMossResultList != None:
            for result in aMossResultList:
                a = result[0][0]
                b = result[1][0]
                if a in self.G.nodes():
                    self.G.node[a]['size'] =  self.G.node[a]['size'] * (float(result[0][1])/100 + 1)
                else:
                    self.G.add_node(a, size = (float(result[0][1])/100 + 1))
                if b in self.G.nodes():
                    self.G.node[b]['size'] =  self.G.node[b]['size'] * (float(result[1][1])/100 + 1)
                else:
                    self.G.add_node(b, size = (float(result[0][1])/100 + 1))
                self.G.add_edge(a, b)
                self.G.edge[a][b]['link'] = result[0][2]
        if aLocalResultDict != {}:
            for local in aLocalResultDict:
                a = local[0]
                b = local[1]
                if not a in self.G.nodes():
                    self.G.add_node(a, size = 1.5)
                if not b in self.G.nodes():
                    self.G.add_node(b, size = 1.5)
                self.G.add_edge(a, b)
                  
    def drawImageToFile(self, aFilename):
        '''
        writes the graph image to aFilename, based on networkx documentation
        '''
        size = self.G.number_of_nodes()/2 #variable figsize avoids node and label superposition
        plt.figure(figsize=(size+2,size+2)) 
        # layout graphs with positions using graphviz neato
        pos = nx.graphviz_layout(self.G)
        # color nodes the same in each connected subgraph
        c = nx.connected_component_subgraphs(self.G)
        for g in c:
            color = [random.random()] * nx.number_of_nodes(g) # random color
            nx.draw(g, pos, node_size=100, node_color=color, alpha=0.5, vmin=0.0, vmax=0.9, with_labels=True)
        plt.savefig(aFilename)