# coding=latin-1
'''
Created on Sep 5, 2011

@author: lucas
'''

import os, commands, urllib2, sys, argparse

from authenticator import Authenticator
from parser import Parser
from writer import Writer
from reporter import Reporter
from detector import Detector
from graph import Graph
from utility import Utility
from detector import Detector

import ipdb
    
if __name__ == '__main__':
    """
    usage example: python main.py  -t http://parati.dca.fee.unicamp.br/adesso/wiki/MAC0417_MAC5748/5122801/view/ -r http://parati.dca.fee.unicamp.br/adesso/wiki/MAC0417_MAC5748/lif_14/view/ -l lucasikeda -p password -m path/to/moss
    """
    try:
        parser = argparse.ArgumentParser(description='Plagiarism checker for Adessowiki.')
        parser.add_argument('-t', metavar='target', type=str, nargs=1, help='target url with suspicious links, ending with /view/')
        parser.add_argument('-r', metavar='url', type=str, nargs=1, help='report destination url, ending with /view/')
        parser.add_argument('-l', metavar='login', type=str, nargs=1, help='user login')
        parser.add_argument('-p', metavar='password', type=str, nargs=1, help='user password')
        parser.add_argument('-m', metavar='mossLocation', type=str, nargs=1, help='path to Moss script file')
        arglist = vars(parser.parse_args())
        for a in arglist:
            if arglist[a] == None:
                raise Exception('Missing argument: %s' %a)
        targetUrl = arglist['t'][0]
        reportUrl = arglist['r'][0]
        login = arglist['l'][0]
        password = arglist['p'][0]
        mossFilePath = arglist['m'][0]
        oldPath = mossFilePath
        mossFilePath = (os.path.realpath(oldPath))
        
        urlRoot = 'http://parati.dca.fee.unicamp.br'
        auth = Authenticator('http://parati.dca.fee.unicamp.br/adesso/accounts/login/?login=Login&next=%2Fadesso%2Fwiki%2F', login, password)
        aPage = auth.openAndRead(targetUrl)
        
        util = Utility()
        parse = Parser(auth)
        accessibleLinks = parse.extractLinks(aPage)
        print 'The following pages will be processed: ', accessibleLinks

        if os.path.exists(os.getcwd() + '/adessoFiles'): #checks and cleans if directory already exists
            os.system("rm -rf adessoFiles")
        os.mkdir('adessoFiles')
        os.chdir('adessoFiles')
        
        for i in range (1, len(accessibleLinks)):
            localParse = Parser(auth)
            currentUrl = urlRoot + accessibleLinks[i]
            if localParse.extractContents(currentUrl) != None:
                localParse.parseContents()
                #writes files for contents
                for j in localParse.dictionary.keys():
                    if localParse.dictionary[j] != '':
                        fileName = util.createFileName(accessibleLinks[i], j)
                        print util.cleanFileName(fileName)
                        outputFile = open(util.cleanFileName(fileName), 'w')
                        outputFile.write(localParse.dictionary[j])
                        outputFile.close()
            else:
                print 'Ignoring ', currentUrl , '\nReason: user-edited contents could not be found.'
        
        #starts detection
        print 'Starting Moss for source-code analysis'
        extensions = ''
        pythonFiles = commands.getoutput("ls *.py").split('\n')
        cppFiles = commands.getoutput("ls *.cpp").split('\n')
        cFiles = commands.getoutput("ls *.c").split('\n')
        if len(pythonFiles) > 1: #there must be at least 2 files for comparison
            extensions += ' *.py '
        if len(cppFiles) > 1:
            extensions += ' *.cpp '
        if len(cFiles) > 1:
            extensions += ' *.c '
        if extensions != '': #if there is some code to analyze
            mossOutput = commands.getoutput(mossFilePath + extensions).splitlines()
            mossUrl = mossOutput.pop()
            print "Moss results will be parsed from ", mossUrl
            mossPage = urllib2.urlopen(mossUrl)
            mossRead = mossPage.read()
            mossResults = parse.parseMossResults(mossRead)
        else:   #no code for analysis
            mossResults = None
            print 'Not enough source code found! Skipping analysis...'
        print 'Starting local Winnowing implementation for natural language text analysis'
        textFiles = commands.getoutput("ls *.txt").split('\n')
        if  len(textFiles) > 1: 
            det = Detector(textFiles)
            localResults = det.runForAll()
        else:
            localResults = {}
            print 'Not enough natural language text found! Skipping analysis...'
        
        #do something with results (draw, upload image and generate report)
        r = Reporter(reportUrl[0:(len(reportUrl)-5)], mossResults, auth, localResults)
        if r.generateReport() == True:
            print 'Execution was successful. Cleaning up files...'
            os.chdir('..')
            os.system("rm -rf adessoFiles") # cleanup files
            print 'Similarity report available on ' + reportUrl
        
    except Exception as e:
        print 'Something went wrong!\nMessage: ', e